﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace practice
{
    /// <summary>
    /// Логика взаимодействия для Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        private gr692_pavContext _context;
        public Window1()
        {
            InitializeComponent();
            _context = new gr692_pavContext();
            Load();
        }
        // вывод данных
        private void Load()
        {
            inventoryGrid.ItemsSource = _context.inventory.ToList();
        }

        // добавление данных
        private void Insert_Click(object sender, RoutedEventArgs e)
        {
            InsertInventory(TbName.Text, TbType.Text);
        }
        public bool InsertInventory(string name, string type)
        {
            if(string.IsNullOrWhiteSpace(name) || string.IsNullOrWhiteSpace(type))
                return false;

            inventory inv = new inventory()
            {
                inventory_name = name,
                inventory_type = type
            };

            _context.inventory.Add(inv);
            _context.SaveChanges();
            Load();
                
            return true;
        }

        // изменение данных
        private void Update_Click(object sender, RoutedEventArgs e)
        {
            UpdateInventory(TbName.Text, TbType.Text);
        }
        public bool UpdateInventory(string name, string type)
        {
            if(inventoryGrid.SelectedItem is inventory selectedInventory)
            {
                if (string.IsNullOrWhiteSpace(name) || string.IsNullOrWhiteSpace(type))
                    return false;

                selectedInventory.inventory_name = name;
                selectedInventory.inventory_type = type;
                _context.SaveChanges();
                Load();

                return true;
            }

            return false;
        }

        // удаление данных
        private void Delete_Click(object sender, RoutedEventArgs e)
        {
            DeleteInventory();
        }
        public void DeleteInventory()
        {
            if(inventoryGrid.SelectedItem is inventory selectedInventory)
            {
                _context.inventory.Remove(selectedInventory);
                _context.SaveChanges();
                Load();
            }
        }

        // выбор строки
        private void inventoryGrid_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if(inventoryGrid.SelectedItem is inventory selectedInventory)
            {
                TbName.Text = selectedInventory.inventory_name;
                TbType.Text = selectedInventory.inventory_type;
            }
        }
    }
}
